#!/bin/sh

# Copyright © 2013-2018 Jakub Wilk <jwilk@jwilk.net>
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the “Software”), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED “AS IS”, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.

set -e -u

if [ -z "${*##-*}" ]
then
    printf 'Usage: %s <shellcat-executable> [extra-args...]\n' "$0"
    exit 1
fi

ifs=$IFS
IFS='
'
export shellcat="$*"
export shellcat_ifs="$IFS"
IFS=$ifs

hr()
{
    printf '%60s' | tr ' ' "$1"
    printf '\n'
}

n_ok=0
n_fail=0
for file in test-*.t
do
    test="${file%.t}"
    printf '%s ... ' "$test"
    rm -f "${test}.report"
    if ( "./$file" 2>&1 ) > "${test}.report"
    then
        rm -f "${test}.report"
        printf 'ok\n'
        n_ok=$(($n_ok + 1))
    else
        printf 'FAIL\n'
        n_fail=$(($n_fail + 1))
    fi
done

printf '\n'

for file in test-*.t
do
    test="${file%.t}"
    [ -e "${test}.report" ] || continue
    hr '='
    printf 'FAILED: %s\n' "$test"
    hr '-'
    cat "${test}.report"
    hr '='
    printf '\n'
done

if [ $n_fail -gt 0 ]
then
    printf 'FAILED (failures=%d)\n' $n_fail
    exit 1
else
    printf 'OK\n'
    exit 0
fi

# vim:ts=4 sts=4 sw=4 et
